// HKDdlg.cpp : implementation file

// HotKey Detective version 1.0
// Copyright (c) 1996 Ziff-Davis Publishing
// First published in PC Magazine June 11, 1996
// Author: Gregory A. Wolking

#include "stdafx.h"
#include "HKD.h"
#include "HKDdlg.h"
#include "HKDpDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg message handlers

BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	// If main window is minimized, center the about box on the screen,
	// otherwise center it over the main window. All other code for the
	// CAboutDlg class was generated by the App Wizard.
	CenterWindow(GetOwner()->IsIconic() ? GetDesktopWindow() : NULL);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

/////////////////////////////////////////////////////////////////////////////
// CHKDDlg dialog
CHKDDlg::CHKDDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHKDDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHKDDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHKDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHKDDlg)
	DDX_Control(pDX, cmdPrint, m_cmdPrint);
	DDX_Control(pDX, lblShortcut, m_lblShortcut);
	DDX_Control(pDX, lblFilename, m_lblFilename);
	DDX_Control(pDX, lblWarning, m_lblWarning);
	DDX_Control(pDX, cmdRefresh, m_cmdRefresh);
	DDX_Control(pDX, chkAutoScan, m_chkAutoScan);
	DDX_Control(pDX, cmdExplore, m_cmdExplore);
	DDX_Control(pDX, lstKeys, m_lstKeys);
	DDX_Control(pDX, lstFiles, m_lstFiles);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHKDDlg, CDialog)
	//{{AFX_MSG_MAP(CHKDDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SYSCOMMAND()
	ON_BN_CLICKED(cmdRefresh, OncmdRefresh)
	ON_LBN_SELCHANGE(lstKeys, OnSelchangelstKeys)
	ON_LBN_DBLCLK(lstKeys, OnDblclklstKeys)
	ON_BN_CLICKED(cmdExplore, OncmdExplore)
	ON_BN_CLICKED(chkAutoScan, OnchkAutoScan)
	ON_WM_SIZE()
	ON_WM_GETMINMAXINFO()
	ON_WM_CLOSE()
	ON_BN_CLICKED(cmdPrint, OncmdPrint)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHKDDlg message handlers
BOOL CHKDDlg::OnInitDialog()
{
	RECT r;

	// Wizard-Generated code.
	CDialog::OnInitDialog();
	CenterWindow();
	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Custom code
	// Load our small and large icons.
    SendMessage(WM_SETICON,(WPARAM)(BOOL)TRUE,(LPARAM)m_hIcon);
    SendMessage(WM_SETICON,(WPARAM)(BOOL)FALSE,(LPARAM)m_hIcon);
	// Set minimum tracking size for use by OnGetMinMaxInfo()
	GetWindowRect(&r);
	min_track_x = r.right - r.left;
	min_track_y = r.bottom - r.top;
	// Unless we're starting minimized, adjust control positions relative
	// to the dialog borders.
	if (!IsIconic())
		Adjust_Controls();
	// Initialize pointer for our worker thread.
	my_thread = NULL;
	// Get paths to the Start Menu and Desktop Folders.
	if (!Get_Folder_Paths())
	{
		// If call fails, report error and quit.
		Do_Error_Message("Could not read Explorer's folder\nsettings from the Registry.");
		EndDialog(IDOK);
	}
	else
	{
		// Create dlg_Scanning screen window (initially hidden).
		dlg_Scanning.Create(IDD_SPLASH, this);
		// Read option settings from the Registry.
		if (!Read_My_Settings())
		{
			// If read fails, set default and save it.
			m_chkAutoScan.SetCheck(1);
			Save_My_Settings();
		}
		// If Automatic Refresh is enabled,
		if (m_chkAutoScan.GetCheck())
			// start our worker thread, which automatically triggers a refresh.
			Launch_Worker();
		else
			// Otherwise, refresh manually.
			OncmdRefresh();
	}
	return TRUE;  // return TRUE unless you set the focus to a control
}

// WM_GETMINMAXINFO handler
// Sets minimum dimensions when window is resized.
void CHKDDlg::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI)
{
	// If dialog doesn't exist yet, controls won't exist either.
	// We don't want to set this metric until the dialog has been
	// created and OnInitDialog() has set the desired size.
	if (m_lblShortcut)
	{
		lpMMI->ptMinTrackSize.x = min_track_x;
		lpMMI->ptMinTrackSize.y = min_track_y;
	}
}

// System menu handler (more Wizard code)
void CHKDDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
		CDialog::OnSysCommand(nID, lParam);
}

// OnCancel is always called last when user exits. Since the user can exit this
// dialog by either clicking the close box or pressing {Esc}, we want to make sure
// that the necessary shutdown work is done regardless of the method used.
// Since there is no special processing required when the Close box is used,
// the CDialog::OnClose() member function is not overriden in this implementation.
void CHKDDlg::OnCancel()
{
	// Make sure worker thread is shut down.
	Kill_Worker();
	// Save auto-refresh setting.
	Save_My_Settings();
	// Destroy the splash screen.
	dlg_Scanning.DestroyWindow();
	// Call base class to finish up and end the application.
	CDialog::OnCancel();
}

// Handles drawing the icon if window is minimized.
// This function and OnQueryDragIcon() are both App Wizard code.
void CHKDDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
		CDialog::OnPaint();
}

// The system calls this to obtain the cursor to display while the user drags
// the minimized window.
HCURSOR CHKDDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// The remainder of this file is custom code.
/////////////////////////////////
// Rearrange controls when dialog is resized
/////////////////////////////////
void CHKDDlg::OnSize(UINT nType, int cx, int cy)
{
	// If the controls exist (On_Size is called once before the controls are drawn),
	if (m_lblShortcut)
		// and we're not being minimized,
		if (nType != SIZE_MINIMIZED)
			// adjust their positions.
			Adjust_Controls();
}

/////////////////////////////
// Command button handlers //
/////////////////////////////

///////////////////////////
// Refresh Key List button.
// Also called by OnInitDialog() and our worker thread.
///////////////////////////
void CHKDDlg::OncmdRefresh()
{
	// Disable button so the user can't stack up refresh requests.
	m_cmdRefresh.EnableWindow(FALSE);
	// If we're not minimized,
	if (!IsIconic())
	{
		// Let the user know we're busy doing something
		dlg_Scanning.CenterWindow();
		dlg_Scanning.ShowWindow(TRUE);
		dlg_Scanning.UpdateWindow();
	}
	// Reset the list boxes.
	m_lstKeys.ResetContent();
	m_lstFiles.ResetContent();
	// Scan the appropriate folders.
	Scan_One_Directory(start_menu_folder, TRUE);
	Scan_One_Directory(desktop_folder, FALSE);
	if (m_lstKeys.GetCount() == 0)
	{
		// Error message if none found.
		Show_Warning("There are no hot keys currently assigned.");
		// Disable the key list and explore and print buttons.
		m_lstKeys.EnableWindow(FALSE);
		m_cmdExplore.EnableWindow(FALSE);
		m_cmdPrint.EnableWindow(FALSE);
		// Erase the shortcut name label.
		m_lblShortcut.SetWindowText("");
	}
	else
	{
		// Enable the key list and explore and print buttons.
		m_lstKeys.EnableWindow(TRUE);
		m_cmdExplore.EnableWindow(TRUE);
		m_cmdPrint.EnableWindow(TRUE);
		// Synchronize the list boxes.
		m_lstKeys.SetCurSel(0);
		m_lstKeys.SetTopIndex(0);
		OnSelchangelstKeys();
		// Display warning caption if duplicates found.
		Check_Dupes();
		// Put focus on the list box.
		m_lstKeys.SetFocus();
	}
	// If the splash screen is visible,
	if (dlg_Scanning.IsWindowVisible())
		// hide it.
		dlg_Scanning.ShowWindow(FALSE);
	// Turn the Refresh button back on.
	m_cmdRefresh.EnableWindow(TRUE);
}

////////////////////////////
// The Explore command button is set as the default button
// so that we can use the {Enter} key to launch Explorer from
// the list box without requiring a separate keyboard message handler for the list box.
///////////////////////////
void CHKDDlg::OncmdExplore()
{
	Launch_Explorer();
}

//////////////////////////
//  Auto-Refresh checkbox.
/////////////////////////
void CHKDDlg::OnchkAutoScan()
{
	// If box is checked,
	if (m_chkAutoScan.GetCheck())
	{
		// Start our worker thread.
		Launch_Worker();
		// If launch failed (which will automatically display a message),
		// the my_thread pointer will be NULL.
		if (my_thread == NULL)
		{
			// Clear the check box.
			m_chkAutoScan.SetCheck(0);
			// Move focus to the Refresh button.
			m_cmdRefresh.SetFocus();
		}
	}
	else
		// Otherwise, shut it down.
		Kill_Worker();
}

///////////////////////
// Print Key List command button.
///////////////////////
void CHKDDlg::OncmdPrint() 
{
	Print_List();
}

/////////////////////
// List box handlers
/////////////////////

///////////////////////////////
// Called when the selection changes in the Key List Box.
///////////////////////////////
void CHKDDlg::OnSelchangelstKeys()
{
	CString scratch;

	// Get corresponding filename text from the file list box,
	m_lstFiles.GetText(m_lstKeys.GetItemData(m_lstKeys.GetCurSel()), scratch);
	// and assign it to the Shortcut label.
	m_lblShortcut.SetWindowText(scratch);
}

/////////////////////////////
// Called when user double-clicks an item in the Key List box.
/////////////////////////////
void CHKDDlg::OnDblclklstKeys()
{
	Launch_Explorer();
}
////////////////////////
// End of event handlers.
////////////////////////

//////////////////////
// "Helper" functions
//////////////////////

///////////////////////////////////////////////////////
// Finds the paths to the current user's Start Menu and Desktop folders.
// Returns FALSE if unable to access the Registry.
///////////////////////////////////////////////////////
BOOL CHKDDlg::Get_Folder_Paths(void)
{
	HKEY myKey;
	BOOL success;

	// Open the Registry key which contains Explorer's settings.
	success = 	!RegOpenKeyEx(	HKEY_CURRENT_USER,
								"Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders",
								NULL,
								KEY_QUERY_VALUE,
								&myKey);
	if (success)
	{
		// Retrieve the paths to the Start Menu and Desktop folders.
		success = Retrieve_Setting(myKey, "Start Menu", &start_menu_folder) &&
				  Retrieve_Setting(myKey, "Desktop", &desktop_folder);
		RegCloseKey(myKey);
	}
	return success;
}

////////////////////////////////////
// Retrieves option settings from the Registry.
// Returns FALSE if unable to access the Registry.
////////////////////////////////////
BOOL CHKDDlg::Read_My_Settings(void)
{
	char classname = 0;
	HKEY myKey;
	ULONG disposition;
	CString values;
	BOOL success;
	int autoscan;

	// Create the key where our settings will be stored. If the key already
	// exists, the function simply opens it.
	if (RegCreateKeyEx(	HKEY_CURRENT_USER, "Software\\PC Magazine\\HotKey Detective",
						0, &classname, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS,
						NULL, &myKey, &disposition) != ERROR_SUCCESS)
		return FALSE;

	// Read the string stored under "AutoScan".
	success = Retrieve_Setting(myKey, "AutoScan", &values);
	RegCloseKey(myKey);
	if (success)
	{
		// Convert the string to a number.
		success = (sscanf(values, "%u", &autoscan) == 1);
		if (success)
			m_chkAutoScan.SetCheck(autoscan);
	}
	return success;
}

////////////////////////////////
// Save options to the Registry.
////////////////////////////////
void CHKDDlg::Save_My_Settings(void)
{
	HKEY myKey;
	CString values;

	// Open the Registry key which contains our settings.
	if (!RegOpenKeyEx(	HKEY_CURRENT_USER, "Software\\PC Magazine\\HotKey Detective",
						NULL, KEY_SET_VALUE, &myKey))
	{
		// If successful, format the checkbox setting into a single string
		// and save it in the Registry.
		values.Format("%u", m_chkAutoScan.GetCheck());
		RegSetValueEx(myKey, "AutoScan", 0, REG_SZ, (LPBYTE) (LPCTSTR) values, values.GetLength() + 1);
		// Close the registry key.
		RegCloseKey(myKey);
	}
}

///////////////////////////////////////////
// Retrieves a single ASCIIZ string from the registry.
// Returns FALSE if any of the Registry API calls fail.
// Note: RegQueryValueEx() returns 0 (ERROR_SUCCESS or FALSE) if the call is successful.
//       If the call fails, the value is a registry error code that we don't need
//       since we're not reporting Registry access errors in detail.
///////////////////////////////////////////
BOOL CHKDDlg::Retrieve_Setting(HKEY hk, char* setting, CString* value)
{
	DWORD data_len;
	BOOL success;

	// Find the length of the string.
	if (success = !RegQueryValueEx(hk, setting, NULL, NULL, NULL, &data_len))
	{
		// If successful, retrieve the string itself.
		success = !RegQueryValueEx(	hk, setting, NULL, NULL,
									(LPBYTE) value->GetBuffer(data_len), &data_len);
		// Clean up the CString after direct buffer access.
		value->ReleaseBuffer();
	}
	return success;
}	

//////////////////////////////////////////
// Walks through all files in the specified directory, passing .LNK and .PIF files
// to Check_One_File(). If walk_tree parameter is TRUE, also recurses 
// through any subdirectories found.
// Function returns FALSE on critical error to prevent infinite recursion.
//////////////////////////////////////////
BOOL CHKDDlg::Scan_One_Directory(LPCTSTR start_path, BOOL walk_tree)
{
	CString current_path(start_path), filename;
	HANDLE find_handle;
	WIN32_FIND_DATA find;

	// Append trailing backslash to path if needed.
	if (current_path.Right(1) != "\\")
		current_path += "\\";
	// Scan all files.
	filename = current_path + "*.*";
	// Find the first matching file.
	find_handle = FindFirstFile(filename, &find);
	if (find_handle != INVALID_HANDLE_VALUE)
	{
		// Loop continues until no more files or critical error occurs.
		while (TRUE)
		{
			// If current item is a directory,
			if (find.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
			{
				// the recursion flag is set,
				if (walk_tree)
				{
					// and the directory name is not "." or "..",
					if ((strcmp(find.cFileName, ".") != 0) &&
						(strcmp(find.cFileName, "..") != 0))
					{
						// then scan that directory.
						if (!Scan_One_Directory(current_path + find.cFileName, TRUE))
							// Bail out if recursive call fails.
							return FALSE;
					}
				}
			}
			// If it's not a directory, it must be a file, so
			else
			{
				// Extract the hot key if possible.
				if (!Check_One_File(current_path + find.cFileName))
					// If fatal error, return FALSE to halt recursion.
					return FALSE;
			}
			// If there are no files left, exit the loop.
			if (!FindNextFile(find_handle, &find))
				break;
		}
	}
	return TRUE;
}

////////////////////////////////////////////////
// Function checks the specified file. If its extension is either .LNK or .PIF,
// it extracts the hot key (if any) and adds it to the list boxes.
// Return values: 
//   If hot key is not set or could not be found, key_code will be set to 0.
//   TRUE = Non-fatal error, e.g.
//          1. Filename passed is not a .LNK or .PIF
//          2. File _is_ .LNK or .PIF but has no shortcut
//          3. Error opening or reading the file.
//   FALSE = Fatal error -- one of the list boxes is full.
// This function is called by the Scan_One_Directory() function.
// The return value tells Scan_One_Directory() whether or not to halt the directory scan
// instead of forcing the user to answer a string of "List box is full" messages.
/////////////////////////////////////////////////
BOOL CHKDDlg::Check_One_File(LPCTSTR fname)
{
	HANDLE myFile;
	CString work_name("");
	LPCTSTR ext;
	char key_name[32];
	LONG lparam;
	int scratch;

	// Make sure global vars are 0
	key_code = 0;
	shift_mask = 0;

	// If filename is less than 5 characters long, we're done.
	scratch = strlen(fname);
	if (scratch <= 4)
		return TRUE;
	else
		// Otherwise, point to the last 4 characters.
		ext = fname + scratch - 4;

	// Set scratch for use in the switch(), or exit the function if the file's extension
	// is neither ".PIF" nor ".LNK" (ignoring upper/lower case).
	if (!stricmp(ext, ".pif"))
		scratch = 1;
	else
	{
		if (!stricmp(ext, ".lnk"))
			scratch = 2;
		else
			return TRUE;
	}

	// Open the file (Don't be confused by the API function name, the OPEN_EXISTING
	// flag tells the function to open the file only if it exists.)
	myFile = CreateFile(fname, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE,
						NULL, OPEN_EXISTING, NULL, NULL);

	// Return if the open fails.
	if (myFile == INVALID_HANDLE_VALUE)
		return TRUE;
	switch (scratch)
	{
	// Handle PIF file (used only for shortcuts to DOS executables).
	case 1:
		// First, try reading offsets based at 1B5h
		key_code = Get_Key_Codes(myFile, 0x1B5, 0x1B7, 0x1BB);
		// If upper bits of shift mask are set, we're not looking at the
		// hot key, so try the alternate offsets.
		if ((shift_mask & 0xF0))
			key_code = Get_Key_Codes(myFile, 0x1D1, 0x1D3, 0x1D7);
		// If key scan code is not 0,
		if (key_code != 0)
		{
			// Convert key name to English.
			// In .PIF files, bit 0 of the byte at the third offset stores a flag
			// indicating extended keys. Moving this to bit 24 of lparam lets
			// GetKeyNameText() identify extended keys properly.
			lparam = (((long) key_code) << 16) | ((ext_key_flag & 1) << 24);
			GetKeyNameText(lparam, key_name, 31);
			// Now, build the full key name starting with the shift mask.
			if (shift_mask & 3)   // Bit 0 = left shift, Bit 1 = right shift
				work_name += "Shift + ";
			if (shift_mask & 4)	  // Bit 2 = Ctrl key.
				work_name += "Ctrl + ";
			if (shift_mask & 8)   // Bit 3 = Alt key.
				work_name += "Alt + ";
			// Concatenate the base key name to the shift mask.
			work_name += key_name;
		}
		break;
	// Handle .LNK file (shortcut to Windows executables, folders, and documents).
	case 2:
		// Hot key is stored at offsets 40H and 41H
		if (key_code = Get_Key_Codes(myFile, 0x40, 0x41, 0))
		{
			// Shell links store the virtual key code, so we have to
			// first convert it to a scan code,
			scratch = MapVirtualKey(key_code, 0) & 0xFF;
			// If conversion was successful,
			if (scratch)
			{
				// get the key's English name.
				// Unlike .PIF files, .LNK files use bit 3 of the shift_mask byte
				// to indicate extended keys instead of a separate byte in the file.
				// Therefore, we must mask out this bit and move it to bit 24 of lparam
				// so that we get the correct English name for extended keys.
				lparam = ((scratch) << 16) | ((shift_mask & 0x8) << 21);
				GetKeyNameText(lparam, key_name, 31);
				// Build key name starting with shift mask
				if (shift_mask & 1)		// Bit 0 = Shift
					work_name += "Shift + ";
				if (shift_mask & 2)		// Bit 1 = Ctrl
					work_name += "Ctrl + ";
				if (shift_mask & 4)		// Bit 2 = Alt
					work_name += "Alt + ";
				// Concatenate base key name to shift mask.
				work_name += key_name;
			}
		}
	}
	// Close the file.
	CloseHandle(myFile);
	// If we got a valid key_name, add it to the list boxes.
	return work_name.IsEmpty() ? TRUE : Add_List_Items(work_name, fname);
}

/////////////////////////////////////////////////////////////////////////////
// Function reads the codes from the specified file at the specified offsets.
// Return value:
//    virtual key code (for .LNK files)
//    keyboard scan code (for .PIF files)
//    0 if no hot key found.
// If successful, mask_offset and/or ext_flag_offset will be set appropriately.
/////////////////////////////////////////////////////////////////////////////
char CHKDDlg::Get_Key_Codes(HANDLE infile, DWORD code_offset, DWORD mask_offset, DWORD ext_flag_offset)
{
	DWORD fpointer, bytes_read;
	BOOL read_result;
	char byte;

	// Seek to the first offset.
	if ((fpointer = SetFilePointer(infile, code_offset, NULL, FILE_BEGIN)) == 0xFFFFFFFF)
		return 0;
	// Try to read one byte.
	read_result = ReadFile(infile, &byte, 1, &bytes_read, NULL);
	if ((!read_result) || (bytes_read != 1))
		return 0;
	// If successful, seek to second offset.
	if ((fpointer = SetFilePointer(infile, mask_offset, NULL, FILE_BEGIN)) == 0xFFFFFFFF)
		return 0;
	// Read one byte.
	read_result = ReadFile(infile, &shift_mask, 1, &bytes_read, NULL);
	if ((!read_result) || (bytes_read != 1))
		return 0;
	// If offset to the extended key flag is 0, we're done -- only .PIF files use this byte.
	if (!ext_flag_offset)
		return byte;
	// Otherwise, retrieve the extended key flag.
	if ((fpointer = SetFilePointer(infile, ext_flag_offset, NULL, FILE_BEGIN)) == 0xFFFFFFFF)
		return 0;
	// Read one byte.
	read_result = ReadFile(infile, &ext_key_flag, 1, &bytes_read, NULL);
	return (!read_result) || (bytes_read != 1) ? 0 : byte;

}

////////////////////////////////////////
// Adds a hotkey item to the list boxes.
// Displays appropriate message and returns FALSE if either list box is full.
////////////////////////////////////////
BOOL CHKDDlg::Add_List_Items(LPCTSTR key, LPCTSTR file)
{
	long index1, index2;

	// Add the filename to lstFiles and save its index position.
	// NOTE: lstFiles must _not_ have the Sorted property set so that existing
	// strings do not move when a new one is added. Note also that the file list box
	// is not visible on the main dialog. It simply provides an effient method to
	// manage a list of variable-length strings.
	if ((index1 = m_lstFiles.AddString(file)) == LB_ERR)
	{
		// Display warning if AddString() fails:
		Do_Error_Message("Filename list is full.");
		return FALSE;
	}
	// Add the hotkey string to lstKeys.
	if ((index2 = m_lstKeys.AddString(key)) == LB_ERR)
	{
		// If key name list is full, remove the string from the file list.
		Do_Error_Message("Hot key list is full.");
		m_lstFiles.DeleteString(index1);
		return FALSE;
	}
	// Set pointer to the corresponding filename in the lstFiles box.
	m_lstKeys.SetItemData(index2, index1);
	return TRUE;
}

/////////////////////////////////////////////////
// Launch explorer with the specified item selected.
/////////////////////////////////////////////////
void CHKDDlg::Launch_Explorer(void)
{
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	HANDLE handle;
	WIN32_FIND_DATA fd;
	CString target, cmdline;
	// Get the filename of the item to be selected.
	m_lblShortcut.GetWindowText(target);
	// Make sure the file already exists.
	handle = FindFirstFile(target, &fd);
	if (handle==INVALID_HANDLE_VALUE)
	{
		// If it doesn't, display an error message and refresh the dialog.
		cmdline = target + "\nno longer exists.";
		Do_Error_Message(cmdline);
		OncmdRefresh();
		return;
	}
	else
		CloseHandle(handle);
	// Command line options tell Explorer to launch in "dual-pane" view
	// with the specified object selected in the right-hand pane.
	cmdline = "explorer /e,/select," + target; 
	// Initialize the STARTUPINFO structure.
	memset(&si, 0, sizeof(si));
	// We _must_ set the structure size before passing pointer to the API call!
	si.cb = sizeof(si);
	// Make sure that Explorer doesn't start minimized.
	si.dwFlags = STARTF_USESHOWWINDOW;
	si.wShowWindow = SW_RESTORE;
	// Try to launch Explorer, display a message if CreateProcess() fails.
	if (!CreateProcess(	NULL, (char *)(LPCTSTR) cmdline, NULL, NULL, FALSE,
						NORMAL_PRIORITY_CLASS, NULL, NULL, &si, &pi))
		Do_Error_Message("Unexpected error launching Explorer.");
}

/////////////////////////
// Generic error message.
/////////////////////////
void CHKDDlg::Do_Error_Message(LPCTSTR msg)
{
	// Make sure the "Scanning" message's window does not obscure the message box.
	if (dlg_Scanning.IsWindowVisible())
		dlg_Scanning.ShowWindow(FALSE);
	MessageBox(msg, "HotKey Detective", MB_ICONEXCLAMATION);
}


////////////////////////
// Check hot key list box for duplicate entries.
// If found, selects first dupe in the list box and displays
// and appropriate message in the Warning label.
////////////////////////
void CHKDDlg::Check_Dupes()
{
	CString previous, next;
	int i, max;

	// Must be at least two items in the list to have duplicates!
	switch (max = m_lstKeys.GetCount())
	{
	case 1:
		// If there's only one, be sure to hide the warning message.
		Show_Warning("");
	case 0:
		return;
	}
	// Retrieve the first string.
	m_lstKeys.GetText(0, previous);
	// Start searching with the second string.
	for (i = 1; i < max; i++)
	{
		// Retrieve next string.
		m_lstKeys.GetText(i, next);
		// Compare to previous string.
		if (previous == next)
		{
			// If it matches, display appropriate warning.
			next = ">>> WARNING <<<\n{" + previous + "}\nis assigned to more than one shortcut.";
			Show_Warning(next);
			// Select the first of the duplicates in the list box.
			m_lstKeys.SetCurSel(--i);
			// Make sure that both duplicates are visible in the list.
			m_lstKeys.SetTopIndex(++i);
			OnSelchangelstKeys();
			// Return to caller.
			return;
		}
		else
			// Otherwise, update the previous string and continue the search.
			previous = next;
	}
	// If loop completes, no dupes were found so clear the warning label.
	Show_Warning("");
}


/////////////////////////////////
// Launches worker thread for Auto Refresh feature.
/////////////////////////////////
void CHKDDlg::Launch_Worker(void)
{
	// Clear flag that signals worker thread to shut down.

	// Create a Mutex object so we can signal the thread to shut down.
	hmy_mutex = CreateMutex(NULL, TRUE, NULL);
	// Launch our worker thread to monitor file system changes.
	// Pass a pointer to ourself so the worker thread can access our
	// data and functions.
	my_thread = AfxBeginThread(Watch_File_System, this, THREAD_PRIORITY_NORMAL, 0, 0, NULL);
	if (my_thread == NULL)
	{
		// If my_thread is NULL, launch failed. Set other flags so
		// the rest of the program knows the thread is not running.
		CloseHandle(hmy_mutex);
		Do_Error_Message("Unable to launch file system monitor.");
	}
}

/////////////////////////////////
// Signals worker thread to terminate and verifies
// that thread has shut down before returning to caller.
///////////////////////////////
void CHKDDlg::Kill_Worker(void)
{
	HANDLE hThread;

	// If thread pointer is not NULL,
	if (my_thread)
	{
		// Get handle to the worker thread.
		hThread = my_thread->m_hThread;
		// Releasing the Mutex object transfers ownership to the the worker thread,
		// satisfying its wait and signalling it to shut down.
		ReleaseMutex(hmy_mutex);
		// Use handle to wait for the thread to terminate.
		while (WaitForSingleObject(hThread, 500) == WAIT_TIMEOUT);
		my_thread = NULL;
		CloseHandle(hmy_mutex);
	}
}

////////////////////////////////////////////////////////////
// Handles the warning message text.
// Used to signal if duplicates are present or if no hot keys are defined.
////////////////////////////////////////////////////////////
void CHKDDlg::Show_Warning(LPCTSTR warning)
{
	if (strlen(warning))
		m_lblWarning.SetWindowText(warning);
	else
		m_lblWarning.SetWindowText("Select a key name to display its associated shortcut's filename below.");
}

////////////////////////////////////////
// Rearrange control positions relative to the client area
// Called when dialog is resized.
///////////////////////////////////////
void CHKDDlg::Adjust_Controls(void)
{
	int midpoint_x, midpoint_y, grid_size, shortcut_label_top;
	RECT client_rect, control_rect;
	RECT work_rect = {0, 0, 0, 0};

	// Get size of client area, and calculate the appropriate dimensions.
	GetClientRect(&client_rect);
	midpoint_x = client_rect.right / 2;
	midpoint_y = client_rect.bottom / 2;
	grid_size = midpoint_y / 5;
	// Shortcut label is always the same height at the bottom of
	// the dialog, stretching its entire width.
	work_rect.right = 60;
	work_rect.bottom = 9;
	MapDialogRect(&work_rect);
	control_rect.left = 4;
	control_rect.top = client_rect.bottom - work_rect.bottom - 4;
	control_rect.right = client_rect.right - 4;
	control_rect.bottom = control_rect.top + work_rect.bottom;
	m_lblShortcut.MoveWindow(&control_rect, FALSE);
	// Shortcut filename's label appears immediately above the box.
	control_rect.top -= work_rect.bottom - 2;
	control_rect.right = control_rect.left + work_rect.right;
	control_rect.bottom = control_rect.top + work_rect.bottom;
	m_lblFilename.MoveWindow(&control_rect, FALSE);
	// Save top of label for use in sizing the key list.
	shortcut_label_top = control_rect.top;
	// Command buttons and checkbox spaced evenly in the lower-right quadrant.
	// Translate button sizes from dialog to screen units:
	work_rect.right = 80;
	work_rect.bottom = 12;
	MapDialogRect(&work_rect);
	control_rect.left = midpoint_x + (midpoint_x - work_rect.right) / 2;
	control_rect.top = midpoint_y + (grid_size - work_rect.bottom) / 2;
	control_rect.right = control_rect.left + work_rect.right;
	control_rect.bottom = control_rect.top + work_rect.bottom;
	m_cmdExplore.MoveWindow(&control_rect, FALSE);
	control_rect.top += grid_size;
	control_rect.bottom += grid_size;
	m_cmdRefresh.MoveWindow(&control_rect, FALSE);
	control_rect.top += grid_size;
	control_rect.bottom += grid_size;
	m_chkAutoScan.MoveWindow(&control_rect, FALSE);
	control_rect.top += grid_size;
	control_rect.bottom += grid_size;
	m_cmdPrint.MoveWindow(&control_rect, FALSE);
	// Center the Warning label in the upper-right quadrant.
	work_rect.right = 84;
	work_rect.bottom = 56;
	MapDialogRect(&work_rect);
	control_rect.left = midpoint_x + (midpoint_x - work_rect.right) / 2;
	control_rect.top = (midpoint_y - work_rect.bottom) / 2;
	control_rect.right = control_rect.left + work_rect.right;
	control_rect.bottom = control_rect.top + work_rect.bottom;
	m_lblWarning.MoveWindow(&control_rect, FALSE);
	// Key list box occupies all available space in the left-hand side.
	work_rect.left = 4;
	work_rect.right = 20;
	work_rect.top = 12;
	work_rect.bottom = 20;
	MapDialogRect(&work_rect);
	work_rect.right = midpoint_x - work_rect.left;
	work_rect.bottom = shortcut_label_top - 4;
	m_lstKeys.MoveWindow(&work_rect, FALSE);
	// Invalidating the entire client area tells the main window
	// to redraw all of its controls at once.
	Invalidate();
}

/////////////////////////  			
// Controlling function for our worker thread.
// Note that this is a global function, not a member function of the CHKDDlg class!
// When this function returns, the thread terminates and the associated CWinThread
// object destroys itself automatically.
// Function has access to CHKDDlg's protected data and functions because
// it is declared as a "friend" to the CHKDDlg class in HKDDLG.H.
/////////////////////////
UINT Watch_File_System(LPVOID pParam)
{
	// Get the pointer to our main dialog so that we can access
	// its member variables and functions.
	CHKDDlg* pThis = (CHKDDlg*) pParam;
	HANDLE hChanges[3] = {NULL, NULL, NULL};
	DWORD wait_status;

	// Refresh the dialog. This ensures that changes made since Automatic Refresh
	// was disabled will not be missed.
	pThis->OncmdRefresh();
	// The third wait object is our Mutex object. It is owned by the main dialog
	// until the dialog is ready for us to shut down.
	hChanges[2] = pThis->hmy_mutex;
    while (TRUE)
    {
		// Open change handles for the file system events we need to track:
		// Changes to the name or last write date of any files
		// in _only_ the Desktop directory.
		hChanges[0] = FindFirstChangeNotification(
			pThis->desktop_folder,
			FALSE,
			FILE_NOTIFY_CHANGE_FILE_NAME | FILE_NOTIFY_CHANGE_LAST_WRITE);
		// Changes to any files or directories in the entire tree rooted at
		// the Start Menu folder.
		hChanges[1] = FindFirstChangeNotification(
			pThis->start_menu_folder,
			TRUE,
			FILE_NOTIFY_CHANGE_FILE_NAME | FILE_NOTIFY_CHANGE_DIR_NAME | FILE_NOTIFY_CHANGE_LAST_WRITE);
		// Wait for one of these three events to occur.
		wait_status = WaitForMultipleObjects(3, hChanges, FALSE, INFINITE);
		// Close the file system wait handles. We could just reset them, but this
		// makes our monitoring _too_ sensitive. Some of Explorer's actions can cause
		// multiple changes to the same object, so closing and reopening the handles
		// prevents the main dialog from refreshing twice or more in rapid succession.
		FindCloseChangeNotification(hChanges[0]);
		FindCloseChangeNotification(hChanges[1]);
		// If the wait function didn't fail,
		if ((wait_status < WAIT_ABANDONED_0) && (wait_status != WAIT_FAILED))
		{
			// see which object satisfied its wait condition.
			if ((wait_status - WAIT_OBJECT_0) == 2)
				// If it was the Mutex object, shut down.
				break;
			else
				// Otherwise, wait until the dialog isn't busy, then
				// tell it to refresh.
			{
					while (!pThis->m_cmdRefresh.IsWindowEnabled())
						// Sleeping for a short interval avoids pounding excessively on the
						// dialog's control while we know the Dialog is already busy.
						Sleep(100);
					pThis->OncmdRefresh();
			}
		}
		else
		{
			// If wait failed, let main dialog know we have shut down due to an unexpected error.
			pThis->m_chkAutoScan.SetCheck(0);
			pThis->my_thread = NULL;
			break;
		}
	}
	// Make sure the mutex object is released before we terminate.
	ReleaseMutex(hChanges[2]);
	return 0;
}

/////////////////////////////
// Print the key list.
/////////////////////////////
void CHKDDlg::Print_List(void)
{
	// Create a simple Print Common Dialog box.
	CPrintDialog dlg(FALSE, PD_NOPAGENUMS | PD_NOSELECTION, NULL);
	CString key_name, shortcut_name, line, work;
	DOCINFO di;
	int pos, i;
	
	// Call the dialog box. If user didn't say OK, nothing to do.
	if (dlg.DoModal() != IDOK)
		return;
	// Create and activate the point size dialog.
	CHKDPointDlg dlg_point;
	// Again, if user didn't say OK, nothing else to do.
	if (dlg_point.DoModal() != IDOK)
		return;
	// Get handle to printer device context.
	hDC = dlg.GetPrinterDC();
	// Save default device context.
	SaveDC(hDC);
	// Initialize DOCINFO structure for the spooler.
	di.cbSize = sizeof(di);
	di.lpszDocName = "HotKey Detective key list";
	di.lpszOutput = NULL;
	di.lpszDatatype = NULL;
	di.fwType = 0;
	// Set output mode.
	SetBkMode(hDC, TRANSPARENT);
	SetMapMode(hDC, MM_TEXT);
	SetTextAlign(hDC, TA_TOP | TA_LEFT);
	// Get number of device units per inch.
	one_inch_x = GetDeviceCaps(hDC, LOGPIXELSX);
	one_inch_y = GetDeviceCaps(hDC, LOGPIXELSY);
	// Get size of physical page.
	page_height = GetDeviceCaps(hDC, PHYSICALHEIGHT);
	page_width = GetDeviceCaps(hDC, PHYSICALWIDTH);
	// Calculate size of printable area.
	page_width -= (one_inch_x + GetDeviceCaps(hDC, PHYSICALOFFSETX));
	page_height -= (one_inch_y + GetDeviceCaps(hDC, PHYSICALOFFSETY));

	// Create an MS Sans Serif font object.
	norm_font = CreateFont(	-MulDiv(dlg_point.m_PointSize, GetDeviceCaps(hDC, LOGPIXELSY), 72),
							0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE, ANSI_CHARSET,
							OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY,
							FF_DONTCARE | DEFAULT_PITCH, "MS Sans Serif");
	// Create an underline MS Sans Serif font object.
	ul_font = CreateFont(	-MulDiv(dlg_point.m_PointSize, GetDeviceCaps(hDC, LOGPIXELSY), 72),
							0, 0, 0, FW_NORMAL, FALSE, TRUE, FALSE, ANSI_CHARSET,
							OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY,
							FF_DONTCARE | DEFAULT_PITCH, "MS Sans Serif");
	// Use custom fonts only if both were created.
	use_custom_font = (norm_font != NULL) && (ul_font != NULL);
	// Start a new document and page.
	StartDoc(hDC, &di);
	StartPage(hDC);
	// Set initial print position.
	text_area.top = one_inch_y / 2;
	text_area.left = one_inch_x / 2;
	for (i=0; i < m_lstKeys.GetCount(); i++)
	{
		// Get key name from the list box.
		m_lstKeys.GetText(i, key_name);
		// Print the name using underline font if possible.
		Print_Line(&key_name, TRUE);
		// Get shortcut filename.
		m_lstFiles.GetText(m_lstKeys.GetItemData(i), shortcut_name);
		// Indent by 4 spaces.
		shortcut_name = "    " + shortcut_name;
		// If there's not enough space to fit it on one line,
		if (Line_Width(shortcut_name) > page_width)
		{
			// Reset output line to blank.
			line = "";
			// As long as the base string is not empty,
			while (!shortcut_name.IsEmpty())
			{
				// If base string contains a backslash.
				if ((pos = shortcut_name.Find('\\')) >= 0)
				{
					// get the substring including the backslash,
					++pos;
					work = shortcut_name.Left(pos);
					// then delete it from the beginning of the base string.
					shortcut_name = shortcut_name.Mid(pos);
				}
				else
				{
					// Otherwise, get the rest of the base string
					work = shortcut_name;
					shortcut_name = "";
				}
				// If next substring will fit,
				if (Line_Width(line) + Line_Width(work) <= page_width)
					// Add it to the current line.
					line += work;
				else
				{
					// Otherwise, print the current line
					Print_Line(&line, FALSE);
					// and start a new line indented an additional 4 spaces.
					line = "        " + work;
					// If the new line is too long, split it at character boundaries.
					while (Line_Width(line) > page_width)
					{
						// Reset the work string to empty.
						work = "";
						// As long as the line is too big,
						while (Line_Width(line) > page_width)
						{
							// Transfer characters from the end of the line
							work = line.Right(1) + work;
							// to the beginning of the work string.
							line = line.Left(line.GetLength() - 1);
						}
						// Print the truncated line.
						Print_Line(&line, FALSE);
						// Indent the remainder and continue
						line = "        " + work;
					}
				}
			}
			// Print the last line.
			Print_Line(&line, FALSE);
		}
		else
			// Otherwise, print the entire filename on one line.
			Print_Line(&shortcut_name, FALSE);
	}
	// End the current page and document.
	EndPage(hDC);
	EndDoc(hDC);
	// Restore the original context.
	RestoreDC(hDC, -1);
	// Delete our custom font objects if they exist.
	if (norm_font)
		DeleteObject(norm_font);
	if (ul_font)
		DeleteObject(ul_font);
	// Delete the device context.
	DeleteDC(hDC);
}

///////////////////////////////////
// Prints a string of text.
// Advances to next page if necessary
//////////////////////////////////
void CHKDDlg::Print_Line(CString* line, BOOL which_font)
{
	// Select appropriate font.
	if (use_custom_font)
		SelectObject(hDC, which_font ? ul_font : norm_font);
	// Calculate maximum remaining print area.
	text_area.right = page_width - text_area.left;
	text_area.bottom = page_height - text_area.top;
	// Find out how much space the text will require.
	DrawText(hDC, *line, -1, &text_area, DT_CALCRECT | DT_LEFT | DT_NOCLIP | DT_NOPREFIX);
	// If there's not enough room,
	if (text_area.bottom > page_height)
	{
		// Save current device context.
		SaveDC(hDC);
		// End the current page and start a new one.
		EndPage(hDC);
		StartPage(hDC);
		// Starting new page resets the device context, so restore the one we just saved.
		RestoreDC(hDC, -1);
		// And make sure we reselect the appropriate font
		if (use_custom_font)
			SelectObject(hDC, which_font ? ul_font : norm_font);
		text_area.top = one_inch_y / 2;
		// Recalculate the area required for our text.
		DrawText(hDC, *line, -1, &text_area, DT_CALCRECT | DT_LEFT | DT_NOCLIP | DT_NOPREFIX);
	}
	// Draw the shortcut filename text.
	DrawText(hDC, *line, -1, &text_area, DT_LEFT | DT_NOCLIP | DT_NOPREFIX);
	// Update print position.
	text_area.top = text_area.bottom;
}

///////////////////////////
// Returns the print width of the specified text string
// in logical device units.
//////////////////////////
int CHKDDlg::Line_Width(LPCTSTR line)
{
	SIZE size;

	GetTextExtentPoint32(hDC, line, strlen(line), &size);
	return size.cx;
}
